--[[  some examples of using arjLib in macros

 currently there's no way for the library to know self-only buffs from those that can be cast upon others.  technically buffs like hunter's aspects can be called without "player" designated as the target, but you'll run the risk of having the spell re-cast if you're targetting a friendly that doesn't have the buff (because it checks the target for the buff by default if no target is designated).

 some of these are theoretical and not tested yet, they may not work as they were meant to.

 p.s.  the CastSpell() function requires a corresponding key-press, so you'll need to put these in a macro key and assign them to an action button to use them.  typing them into the chat frame will not work.
 
 p.p.s.  obviously, any call to cact() needs the action name called in one of the action bar slots, but this slot can be hidden or on a page not currently shown on-screen.

]]--


--[[ general ]]--
-- switch tracking for mining and herbalism
/script ctrack("Find Minerals","Find Herbs")

-- announce target's info on various channels
/script if(IsAltKeyDown()) then cinfo() elseif(IsControlKeyDown()) then cinfo("guild") else cinfo("party") end

-- undead eats lunchies...
/script if(ibuff("Cannibalize","player")) then SendChatMessage("Mmmmmm, tastes like chicken!","say") else ctop("Cannibalize") end

-- undead fear counter
/script if(not ctop("Will of the Forsaken")) then citem("Insignia of the Horde") end



--[[ druid ]]--
-- buff spam
/script pbuff("Mark of the Wild") local t=pbuff("Thorns","Druid","Warrior","Paladin","Rogue") if(t) then pchat("Do I make you thorny, baby?",t) end cbuff("Omen of Clarity","player")

-- heal lowest party / raid member
/script if(IsAltKeyDown()) then pheal("Rejuvenation") elseif(IsControlKeyDown()) then pheal("Regrow") else pheal("Healing Touch") end

-- bear form melee spam
/script if(cact("Feral Charge") and math.random(10)==1) then DoEmote("charge") end if(cattack()) then cact("Maul") end

-- cat form melee spam
/script local c,h=GetComboPoints(),UnitHealth("target") if((c>0 and h<30) or c>4) then if(h>30) then cact("Rip") else cact("Ferocious Bite") end else cact("Shred") cdebuff("Rake") cact("Claw") end cattack()

-- forms (sending null forms (like "Caster") returns you to a neutral state)
/script if(IsAltKeyDown()) then cshape("Bear Form") elseif(IsControlKeyDown()) then cshape("Cat Form") else cshape("Caster") end

-- destroy totems
/script local t={"Earthbind","Searing","Fire Nova","Magma","Windfury"} for i in t do TargetByName(t[i].." Totem") if(UnitName("target")==t[i].." Totem") then ctop("Moonfire","target",1) TargetLastTarget() break end end



--[[ hunter ]]--
-- call/revive or dismiss pet toggle (doesn't seem to work all the time...)
/script if(IsAltKeyDown()) then ctop("Revive Pet") elseif(PetCanBeAbandoned()) then if(UnitHealth("pet")>1) then ctop("Dismiss Pet") else ctop("Revive Pet") end else ctop("Call Pet") end

-- cast mark (if needed) and have pet attack
/script cpet("Attack") if(cdebuff("Hunter's Mark") and math.random(10)==1) then DoEmote("charge") end

-- ranged spam (w/ pull)
/cast Auto Shot
/script if(not UnitAffectingCombat("target")) then ctop("Arcane Shot") end cbuff("Aspect of the Hawk","player") cdebuff("Serpent Sting") ctop("Aimed Shot")

-- ranged spam (w/ concussion)
/cast Auto Shot
/script cbuff("Aspect of the Hawk","player") cdebuff("Concussive Shot") cdebuff("Serpent Sting") ctop("Arcane Shot")

-- scatter shot
/script if(cdebuff("Scatter Shot")) then PetFollow() cpet("Prowl") end

-- melee spam
/script cbuff("Aspect of the Monkey","player") if(cattack()) then cact("Mongoose Bite") cact("Raptor Strike") end

-- slow melee
/script cbuff("Aspect of the Monkey","player") if(cattack() and not idebuff("Counterattack") and not idebuff("Wing Clip")) then cact("Counterattack") cact("Wing Clip") end end

-- tracking switch
/script ctrack("Track Humanoids","Track Hidden","Track Beasts")

-- panic
/script if(PlayerFrame.inCombat) then ctop("Feign Death") cpet("Follow") cpet("Prowl") cpet("Prowl") end ctop("Freezing Trap")



--[[ mage ]]--
-- do and say sheep
/script if(cdebuff("Polymorph")) then pchat("shEEping >> %t <<") end

-- buff spam
/script cbuff("Frost Armor","player") pbuff("Arcane Intellect","Druid","Hunter","Mage","Paladin","Priest","Shaman")



--[[ priest ]]--
-- tank love
/script if(not idebuff("Weakened Soul")) then cbuff("Power Word: Shield") end cbuff("Renew")

-- heal lowest in party
/script if(IsControlKeyDown()) then pheal("Heal") elseif(IsAltKeyDown()) then pheal("Flash Heal") else pheal("Greater Heal") end

-- renew lowest in party
/script pheal("Renew")

-- buff spam
/script cbuff("Inner Fire","player") cbuff("Touch of Weakness","player") cbuff("Shadow Protection") local t=pbuff("Divine Spirit") or  if(t) then pchat("Do you feel the Spirit, brother?",t) end t=pbuff("Power Word: Fortitude") if(t) then pchat("May the Fort be with you.",t) end

-- rezz and announce (doesn't work if toon has released =/)
/script local t=pres("Resurrection","Priest","Shaman") if(t) then pchat("reZZing >> "..t.." <<") end

-- remove debuffs
/script pdebuff("Dispel Magic","Magic") pdebuff("Abolish Disease","Disease")

-- shadow damage spam
/script cdebuff("Shadow Word: Pain") cdebuff("Vampiric Embrace") ctop("Mind Blast") ctop("Mind Flay")

-- annonce shackle
/script if(cbuff("Shackle Undead")) then pchat("shackle on  >> %t <<  don't touch") end



--[[ rogue ]]--
-- ss unless low health (hmm, way to know if behind target?)
/script if(cattack()) then local c,h=GetComboPoints(),UnitHealth("target") if(c>4 or (c>0 and h<30)) then cact("Eviscerate") end if(c>3 and h>50) then cbuff("Adrenaline Rush") cbuff("Slice and Dice") end cact("Riposte") cact("Sinister Strike") end

-- speed
/script cbuff("Blade Flurry","player") cbuff("Slice and Dice","player")

-- apply poisons
/script if(IsAltKeyDown()) then if(citem("Deadly Poison IV")) then PickupInventoryItem(17) end else if(citem("Crippling Poison II")) then PickupInventoryItem(16) end end ClearCursor()

-- gouge / blind then bandage
/script if(idebuff("Gouge") or idebuff("Blind")) then citem("Heavy Runecloth Bandage","player") else cact("Gouge") 


--[[ shaman ]]--
-- melee spam
/script cbuff("Lightning Shield","player") if(cattack()) then cdebuff("Flame Shock") else ctop("Lightning Bolt") end 

-- buff spam (weapon enchants don't report same as other buffs =/)
/script cbuff("Rockbiter Weapon","player")

-- heal lowest in party
/script pheal("Healing Wave")

-- emergancey heal
/script cbuff("Nature's Swiftness","player") ctop("Healing Wave")

-- ranged damage spam
/script cbuff("Elemental Focus","player") cdebuff("Frost Shock") cdebuff("Flame Shock") ctop("Earth Shock")

-- spell inturrupt (casts Earth Shock (Rank 1))
/script ctop("Earth Shock","target",1)



--[[ warlock ]]--
-- buff
/script cbuff("Demon Skin","player") if(not ibuff("Fire Shield","player")) then TargetUnit("player") cpet("Fire Shield") TargetLastTarget() end

-- DoTs
/script cdebuff("Corruption") cdebuff("Curse of Agony") cdebuff("Immolate")

-- damage spam
/script cattack() cpet("Attack") ctop("Shadow Bolt")



--[[ warrior ]]--
-- battle stance melee spam
/script cact("Charge") if(cattack()) then cact("Overpower") cact("Execute") cbuff("Bloodrage") cdebuff("Rend") cact("Heroic Strike") end cbuff("Battle Shout")

-- battle stance spam w/ hamstring
/script if(cattack()) then cdebuff("Hamstring") cact("Execute") cact("Overpower") cdebuff("Rend") cact("Heroic Strike") end

-- defensive stance melee spam
/script if(cattack()) then if(UnitIsUnit("targettarget","player")) then cact("Shield Block") cdebuff("Disarm") else cact("Revenge") cact("Taunt") end if(idebuff("Sunder Armor")==5) then cact("Heroic Strike") end cact("Sunder Armor") end 

-- sunder armor for threat, rage and profit
/script local s,x=idebuff("Sunder Armor"),{[0]="him",[1]="her",[2]="it"} if(s and s==5) then pchat("%t sundered "..s.." times, jump "..x[UnitSex("target")].."!") end cdebuff("Sunder Armor","target",5)
